#Compile Exe              "CC.Exe"         'C:\Code\PwrBasic\PBWin90\CC\CC.Exe
#Dim                      All
#Register                 None
#Include                  "Win32Api.inc"
#Include                  "ObjBase.inc"
#Include                  "OAIdl.inc"
#Include                  "Registry.inc"

                          'IClassFactory1 Interface Function Pointers
Declare Function          ptrCreateInstance (Byval this As Dword, Byval pUnk As Dword, Byref iid As Guid, Byref ppv As Dword) As Long
Declare Function          ptrLockServer     (Byval this As Dword, Byval blnLock As Long                                     ) As Long

                          'IX, IY Interface Function Pointer Prototypes
Declare Function          ptrQueryInterface (Byval this As Dword, Byref iid As Guid, Byref pUnknown As Dword                ) As Long
Declare Function          ptrAddRef         (Byval this As Dword                                                            ) As Dword
Declare Function          ptrRelease        (Byval this As Dword                                                            ) As Dword
Declare Function          ptrSetInt         (Byval this As Dword, Byval iVal As Long                                        ) As Long
Declare Function          ptrGetInt         (Byval this As Dword, Byref pVal As Long                                        ) As Long
Declare Function          ptrSetText        (Byval this As Dword, Byval strText As String                                   ) As Long
Declare Function          ptrGetText        (Byval this As Dword, Byref ptrText As String                                   ) As Long

$IID_IClassFactory        =  Guid$("{00000001-0000-0000-C000-000000000046}")
$IID_IUnknown             =  Guid$("{00000000-0000-0000-C000-000000000046}")
$CLSID_CC                 =  Guid$("{20000000-0000-0000-0000-000000000020}")
$IID_IX                   =  Guid$("{20000000-0000-0000-0000-000000000021}")
$IID_IY                   =  Guid$("{20000000-0000-0000-0000-000000000022}")
$LIBID_CCLibrary          =  Guid$("{20000000-0000-0000-0000-000000000023}")
$CLSID_Junk               =  Guid$("{12345678-9876-5432-1012-345678901234}")
$IID_Junk                 =  Guid$("{12345678-9876-5432-1012-345678901234}")

Type IXVtbl
  QueryInterface          As Dword Ptr
  AddRef                  As Dword Ptr
  Release                 As Dword Ptr
  SetXInt                 As Dword Ptr
  GetXInt                 As Dword Ptr
  SetXText                As Dword Ptr
  GetXText                As Dword Ptr
End Type

Type I_X
  lpIX                    As IXVtbl Ptr
End Type

Type IYVtbl
  QueryInterface          As Dword Ptr
  AddRef                  As Dword Ptr
  Release                 As Dword Ptr
  SetYInt                 As Dword Ptr
  GetYInt                 As Dword Ptr
  SetYText                As Dword Ptr
  GetYText                As Dword Ptr
End Type

Type I_Y
  lpIY                    As IYVtbl Ptr
End Type

Type CC
  lpIX                    As IXVtbl Ptr
  lpIY                    As IYVtbl Ptr
  m_iXInt                 As Long
  m_iYInt                 As Long
  m_XText                 As Dword Ptr
  m_YText                 As Dword Ptr
  m_cRef                  As Long
End Type

Type IClassFactoryVtbl
  QueryInterface          As Dword Ptr
  AddRef                  As Dword Ptr
  Release                 As Dword Ptr
  CreateInstance          As Dword Ptr
  LockServer              As Dword Ptr
End Type

Type IClassFactory1
  lpVtbl                  As IClassFactoryVtbl Ptr
End Type

Global g_szFriendlyName   As Asciiz*64
Global g_szVerIndProgID   As Asciiz*64
Global g_szProgID         As Asciiz*64
Global CCClassFactory     As IClassFactory1     'sizeof() =  4
Global IClassFactory_Vtbl As IClassFactoryVtbl  'sizeof() = 20
Global IX_Vtbl            As IXVtbl             'sizeof() = 28
Global IY_Vtbl            As IYVtbl             'sizeof() = 28
Global g_hModule          As Dword
Global g_lLocks           As Long


Sub CCLock()
  Print "  Entering CCLock()"
  Print "    g_lLocks = " g_lLocks
  Call InterlockedIncrement(g_lLocks)
  Print "    g_lLocks = " g_lLocks
  Print "  Leaving CCLock()"
End Sub


Sub CCUnLock()
  If g_lLocks > 0 Then
     Print "Entering CCUnLock()"
     Print "  g_lLocks = " g_lLocks
     Call InterlockedDecrement(g_lLocks)
     Print "  g_lLocks = " g_lLocks
     If g_lLocks=0 Then
        Call PostQuitMessage(0)
     End If   
  Print "Leaving CCUnLock()"
  End If   
End Sub


Function IX_QueryInterface(ByVal this As I_X Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      Print "  Called IX_QueryInterface() For IID_IUnknown And this=" this
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IX
      Print "  Called IX_QueryInterface() For IID_IX And this=" this
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IY
      Print "  Called IX_QueryInterface() For IID_IY And this=" this
      Incr this
      @ppv=this
      Call IY_AddRef(this)
      Function=%S_OK
      Exit Function
    Case Else
      Print "Called IX_QueryInterface()"
  End Select

  Function=%E_NoInterface
End Function


Function IX_AddRef(ByVal this As I_X Ptr) As Long
  Local pCC As CC Ptr

  Print "Called IX_AddRef()"
  pCC=this
  Incr @pCC.m_cRef

  IX_AddRef=@pCC.m_cRef
End Function


Function IX_Release(ByVal this As I_X Ptr) As Long
  Local pCC As CC Ptr

  pCC=this
  Decr @pCC.m_cRef
  If @pCC.m_cRef=0 Then
     Call CoTaskMemFree(this)
     Call CCUnLock()
     Print "Called IX_Release() And CC Was Deleted!"
  Else
     Print "Called IX_Release()"
  End If

  Function=@pCC.m_cRef
End Function


Function SetXInt(ByVal this As I_X Ptr, Byval iXVal As Long) As Long
  Local pCC As CC Ptr

  Print "Called SetXInt(" & Trim$(Str$(iXVal)) & ")"
  pCC=this
  @pCC.m_iXInt=iXVal

  Function=%S_OK
End Function


Function GetXInt(ByVal this As I_X Ptr, Byref pXVal As Long) As Long
  Local pCC As CC Ptr

  pCC=this
  pXVal=@pCC.m_iXInt
  Print "Called GetXInt(" & Trim$(Str$(pXVal)) & ")"

  Function=%S_OK
End Function


Function SetXText(ByVal this As I_X Ptr, Byval strXText As String) As Long
  Local pCC As CC Ptr

  Print "Setting IXText To " & strXText
  pCC=this
  If SysReAllocString(@pCC.m_XText, Byval Strptr(strXText)) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
End Function


Function GetXText(ByVal this As I_X Ptr, Byref strXText As String) As Long
  Local pCC As CC Ptr

  pCC=this
  If SysReAllocString(strXText, Byval @pCC.m_XText) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
  Print "IX Text: " & strXText
End Function


Function IY_QueryInterface(ByVal this As I_Y Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      Print "Called IY_QueryInterface() For IID_IUnknown"
      Decr this
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IX
      Print "Called IY_QueryInterface() For IID_IX"
      Decr this
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IY
      Print "Called IY_QueryInterface() For IID_IY"
      @ppv=this
      Call IY_AddRef(this)
      Function=%S_OK
      Exit Function
    Case Else
      Print "Called IY_QueryInterface()"
  End Select

  Function=%E_NoInterface
End Function


Function IY_AddRef(ByVal this As I_Y Ptr) As Long
  Local pCC As CC Ptr

  Print "Called IY_AddRef()"
  Decr this
  pCC=this
  Incr @pCC.m_cRef

  IY_AddRef=@pCC.m_cRef
End Function


Function IY_Release(ByVal this As I_Y Ptr) As Long
  Local pCC As CC Ptr

  Decr this
  pCC=this
  Decr @pCC.m_cRef
  If @pCC.m_cRef=0 Then
     Call CoTaskMemFree(this)
     Call CCUnLock()
     Print "Called IY_Release() And CB Was Deleted!"
  Else
     Print "Called IY_Release()"
  End If

  Function=@pCC.m_cRef
End Function


Function SetYInt(ByVal this As I_Y Ptr, Byval iYVal As Long) As Long
  Local pCC As CC Ptr

  Print "Called SetYInt(" & Trim$(Str$(iYVal)) & ")"
  Decr this
  pCC=this
  @pCC.m_iYInt=iYVal

  Function=%S_OK
End Function


Function GetYInt(ByVal this As I_Y Ptr, Byref pYVal As Long) As Long
  Local pCC As CC Ptr

  Decr this
  pCC=this
  pYVal=@pCC.m_iYInt
  Print "Called GetXInt(" & Trim$(Str$(pYVal)) & ")"

  Function=%S_OK
End Function


Function SetYText(ByVal this As I_Y Ptr, Byval strYText As String) Export As Long
  Local pCC As CC Ptr

  Print "Setting IYText To " & strYText
  Decr this
  pCC=this
  If SysReAllocString(@pCC.m_YText, Byval Strptr(strYText)) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
End Function


Function GetYText(ByVal this As I_Y Ptr, Byref strYText As String) Export As Long
  Local pCC As CC Ptr

  Decr this
  pCC=this
  If SysReAllocString(strYText, Byval @pCC.m_YText) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
  Print "IY Text: " & strYText
End Function


Function CCClassFactory_QueryInterface(ByVal this As IClassFactory1 Ptr, ByRef RefIID As Guid, ByVal pCF As Dword Ptr) As Long
  Print "Called CCClassFactory_QueryInterface()"
  If RefIID=$IID_IUnknown Or RefIID=$IID_IClassFactory Then
     Call CCClassFactory_AddRef(this)
     @pCF=this
     Print "  Leaving CCClassFactory_QueryInterface()"
     Function=%NOERROR
     Exit Function
  End If

  Function=%E_NoInterface
End Function


Function CCClassFactory_AddRef(ByVal this As IClassFactory1 Ptr) As Long
  Print "Called CCClassFactory_AddRef()!"
  'Print "    Leaving CCClassFactory_AddRef()!"
  CCClassFactory_AddRef=10
End Function


Function CCClassFactory_Release(ByVal this As IClassFactory1 Ptr) As Long
  Print "Called CCClassFactory_Release()!"
  'Print "    this=" this
  'Print "  Leaving CCClassFactory_Release()!"
  CCClassFactory_Release=20
End Function


Function CCClassFactory_CreateInstance(ByVal this As IClassFactory1 Ptr, ByVal pUnknown As Dword, ByRef RefIID As Guid, ByVal ppv As Dword Ptr) As Long
  Local strIXStr, strIYStr As String
  Local pIX As I_X Ptr
  Local pCC As CC Ptr
  Local hr  As Long

  Print "Called CCClassFactory_CreateInstance()"
  @ppv=%NULL
  If pUnknown Then
     hr=%CLASS_E_NOAGGREGATION
     Exit Function
  Else
     If RefIID=$IID_IUnknown Or RefIID=$IID_IX Or RefIID=$IID_IY Then
        pCC=CoTaskMemAlloc(SizeOf(CC))
        If pCC Then
           Print "  pCC      ="pCC
           @pCC.lpIX=VarPtr(IX_Vtbl)
           @pCC.lpIY=VarPtr(IY_Vtbl)
           Print "  @pCC.lpIX=" @pCC.lpIX
           Print "  @pCC.lpIY=" @pCC.lpIY : Print
           Print " " Varptr(@pCC.lpIX), @pCC.lpIX
           Print " " Varptr(@pCC.lpIY), @pCC.lpIY  : Print
           strIXStr="Default IX Interface String"
           strIYStr="Default IY Interface String"
           strIXStr=UCode$(strIXStr)
           strIYStr=UCode$(strIYStr)
           @pCC.m_XText=SysAllocStringLen(Byval Strptr(strIXStr),Len(strIXStr)+1)
           @pCC.m_YText=SysAllocStringLen(Byval Strptr(strIYStr),Len(strIYStr)+1)
           @pCC.m_cRef=0
           pIX=pCC
           hr= IX_QueryInterface(pIX,RefIID,ppv)
           Print "  pCC  = " pCC
           Print "  pIX  = " pIX
           Print "  @ppv = " @ppv
           If SUCCEEDED(hr) Then
              Call CCClassFactory_AddRef(this)
              Call CCLock()
           Else
              Call CoTaskMemFree(pCC)
              CCClassFactory_CreateInstance=%E_FAIL
              Print : Print "CreateInstance Failed!"
              Exit Function
           End If
        Else
           hr=%E_OutOfMemory
           Exit Function
        End If
     Else   
        hr=%E_FAIL
        Exit Function
     End If
  End If   
  Print "Leaving CBClassFactory_CreateInstance()"

  CCClassFactory_CreateInstance=%S_Ok
End Function


Function CCClassFactory_LockServer(ByVal this As IClassFactory1 Ptr, Byval flock As Long) As Long
  Print "Called CCClassFactory_LockServer()"
  If flock Then
     Call CCLock()
  Else
     Call CCUnLock()
  End If

  CCClassFactory_LockServer=%NOERROR
End Function


Function ExeRegisterServer(hInstance As Long) As Long
  Local strAsciPath,strWideCharPath As String
  Local hr,iBytesReturned As Long
  Local szPath As Asciiz*256
  Local pTypeLib As ITypeLib
  
  Print "  Entering ExeRegisterServer()"
  If GetModuleFileName(hInstance, szPath, 256) Then
     Print "    szPath         = " szPath
     strAsciPath=szPath
     strWideCharPath=UCode$(strAsciPath & $Nul)
     hr=LoadTypeLibEx(Strptr(strWideCharPath), %REGKIND_REGISTER, pTypeLib)
     If SUCCEEDED(hr) Then
        Print "    LoadTypeLib() Succeeded!"
        'Call pTypeLib.Release()
        Set pTypeLib = Nothing
        hr=RegisterServer(szPath, $CLSID_CC, $LIBID_CCLibrary, g_szFriendlyName, g_szVerIndProgID, g_szProgID)
     Else
        Local dwFlags As Dword
        Local szError As Asciiz*256
        Print "    LoadTypeLib() Failed!"
        iBytesReturned= _
        FormatMessage _
        ( _
          dwFlags, _
          Byval 0, _
          hr, _
          MAKELANGID(%LANG_NEUTRAL, %SUBLANG_DEFAULT), _
          Byval Varptr(szError), _
          256, _
          Byval %NULL _
        )
        Print "    iBytesReturned = " iBytesReturned
        Print "szBuffer           = " szError
     End If
  End If
  Print "  Leaving ExeRegisterServer()"

  Function=hr
End Function


Function ExeUnregisterServer(hInstance As Long) As Long
  Print "  Entering ExeUnregisterServer()"
  Print "    Not Implemented Yet!"
  Print "  Leaving ExeUnregisterServer()"
End Function


Function blnRegistration(Byval hInstance As Long, Byval lpCmdLine As Asciiz Ptr, Byref regID As Dword) As Long
  Local hr As Long

  Print "Entering blnCmdLineProcessing()"
  If InStr(@lpCmdLine,"/r") Then
     Print "  Calling ExeRegisterServer()"
     Call ExeRegisterServer(hInstance)
     Print "Leaving blnCmdLineProcessing()"
     Print
     Function=%TRUE
     Exit Function
  End If
  If InStr(@lpCmdLine,"/u") Then
     Print "  Calling ExeUnregisterServer()"
     Call ExeUnregisterServer(hInstance)
     Print "Leaving blnCmdLineProcessing()"
     Print
     Function=%TRUE
     Exit Function
  End If
  Print "Leaving blnCmdLineProcessing()"
  Print

  Function=%FALSE
End Function


Function Initialize() As Long
  Local pClsFac As Dword Ptr
  Local hr As Long

  Print "Entering Initialize()" 
  g_szFriendlyName                           = "Com Object CC"
  g_szProgID                                 = "ComObject.CC.1"
  g_szVerIndProgID                           = "ComObject.CC"
  IClassFactory_Vtbl.QueryInterface          = CodePtr(CCClassFactory_QueryInterface)
  IClassFactory_Vtbl.AddRef                  = CodePtr(CCClassFactory_AddRef)
  IClassFactory_Vtbl.Release                 = CodePtr(CCClassFactory_Release)
  IClassFactory_Vtbl.CreateInstance          = CodePtr(CCClassFactory_CreateInstance)
  IClassFactory_Vtbl.LockServer              = CodePtr(CCClassFactory_LockServer)
  CCClassFactory.lpVtbl                      = VarPtr(IClassFactory_Vtbl)
  Print "  IClassFactory_Vtbl.QueryInterface = " IClassFactory_Vtbl.QueryInterface
  Print "  IClassFactory_Vtbl.AddRef         = " IClassFactory_Vtbl.AddRef
  Print "  IClassFactory_Vtbl.Release        = " IClassFactory_Vtbl.Release
  Print "  IClassFactory_Vtbl.CreateInstance = " IClassFactory_Vtbl.CreateInstance
  Print "  IClassFactory_Vtbl.LockServer     = " IClassFactory_Vtbl.LockServer
  Print
  Print "  Varptr(CCClassFactory)            = " Varptr(CCClassFactory)
  Print "  Varptr(CCClassFactory.lpVtbl)     = " Varptr(CCClassFactory.lpVtbl)
  Print "  Varptr(IClassFactory_Vtbl)        = " Varptr(IClassFactory_Vtbl)
  Print "  CCClassFactory.lpVtbl             = " CCClassFactory.lpVtbl  
  IX_Vtbl.QueryInterface                     = CodePtr(IX_QueryInterface)
  IX_Vtbl.AddRef                             = CodePtr(IX_AddRef)
  IX_Vtbl.Release                            = CodePtr(IX_Release)
  IX_Vtbl.SetXInt                            = CodePtr(SetXInt)
  IX_Vtbl.GetXInt                            = CodePtr(GetXInt)
  IX_Vtbl.SetXText                           = CodePtr(SetXText)
  IX_Vtbl.GetXText                           = CodePtr(GetXText)
  IY_Vtbl.QueryInterface                     = CodePtr(IY_QueryInterface)
  IY_Vtbl.AddRef                             = CodePtr(IY_AddRef)
  IY_Vtbl.Release                            = CodePtr(IY_Release)
  IY_Vtbl.SetYInt                            = CodePtr(SetYInt)
  IY_Vtbl.GetYInt                            = CodePtr(GetYInt)
  IY_Vtbl.SetYText                           = CodePtr(SetYText)
  IY_Vtbl.GetYText                           = CodePtr(GetYText)
  'hr=CCClassFactory_QueryInterface(VarPtr(CCClassFactory), $IID_IClassFactory, Varptr(CCClassFactory))
  hr=CCClassFactory_QueryInterface(VarPtr(CCClassFactory), $IID_IClassFactory, Varptr(pClsFac))
  If FAILED(hr) Then
     CCClassFactory.lpVTbl=0
     hr=%CLASS_E_CLASSNOTAVAILABLE
     Exit Function
  Else
     'Print "  VarPtr(CCClassFactory) = " Varptr(CCClassFactory)
     Print "  pClsFac = " pClsFac
  End If
  Print "Leaving Initialize()" : Print

  Function=hr
End Function


Sub DumpClassObject()
  Local pClassFactory As IClassFactory1 Ptr
  Local pVtbl,Vtbl As Dword Ptr
  Local pUnk As Dword
  Register i As Long
  Local hr As Long
  
  Print
  Print "Entering DumpClassObject()"
  pClassFactory=Varptr(CCClassFactory)
  pVtbl = pClassFactory
  Print "  pClassFactory         = " pClassFactory
  Print "  @pClassFactory        = " @pVtbl
  Print "  @pClassFactory.lpVtbl = " @pClassFactory.lpVtbl
  Vtbl=@pClassFactory.lpVtbl
  Print
  Print "pClassFactory  Varptr(@Vtbl[i]   @Vtbl[i]    Function Call Through Fn Ptr"
  Print "=======================================================================================" 
  Print pClassFactory, Varptr(@Vtbl[0]) Tab(33) @Vtbl[0] "    ";
  Call Dword @Vtbl[0] Using ptrQueryInterface(Varptr(@pVtbl[0]), $IID_Junk, pUnk) To hr           'QueryInterface() 
  Print pClassFactory, Varptr(@Vtbl[1]) Tab(33) @Vtbl[1] "    ";
  Call Dword @Vtbl[1] Using ptrAddRef(Varptr(@pVtbl[0])) To hr                                    'AddRef()
  Print pClassFactory, Varptr(@Vtbl[2]) Tab(33) @Vtbl[2] "    ";
  Call Dword @Vtbl[2] Using ptrRelease(Varptr(@pVtbl[0])) To hr                                   'Release()
  Print pClassFactory, Varptr(@Vtbl[3]) Tab(33) @Vtbl[3] "    ";
  Call Dword @Vtbl[3] Using ptrCreateInstance(Varptr(@pVtbl[0]), %NULL, $CLSID_Junk, pUnk) To hr  'CreateInstance()
  Print pClassFactory, Varptr(@Vtbl[4]) Tab(33) @Vtbl[4] "    ";
  Call Dword @Vtbl[4] Using ptrLockServer(Varptr(@pVtbl[0]), %FALSE) To hr                        'LockServer()
  Print 
  Print "Leaving DumpClassObject()" : Print
End Sub


Sub DumpCustomInterfaces()
  Local pVTbl,VTbl As Dword Ptr
  Local strBStr As String
  Local iReturn As Long
  Local pUnk As Dword
  Register i As Long
  Local hr As Long
  
  Print "Entering DumpCustomInterfaces()" : Print
  hr=CCClassFactory_CreateInstance(Varptr(CCClassFactory), pUnk, $IID_IX, Varptr(pVTbl))
  Print "VarPtr(pVTbl) = " Varptr(pVTbl)
  Print "pVTbl         = " pVTbl
  Print
  Print "Varptr(@pVTbl[i])  Varptr(@VTbl[i])  @VTbl[i]   Function Call With Call Dword"
  Print "=============================================================================="
  For i=0 To 1
    VTbl=@pVTbl[i]                                                                          'Call...
    Print LTrim$(Str$(Varptr(@pVTbl[i]))) Tab(19)Varptr(@VTbl[0]) Tab(37)@VTbl[0] "   ";
    Call DWord @VTbl[0] Using ptrQueryInterface(Varptr(@pVTbl[i]), $IID_Junk, pUnk) To hr   'QueryInterface()
    Print LTrim$(Str$(Varptr(@pVTbl[i]))) Tab(19)Varptr(@VTbl[1]) Tab(37)@VTbl[1] "   ";
    Call DWord @VTbl[1] Using ptrAddRef(Varptr(@pVTbl[i])) To hr                            'AddRef()
    Print LTrim$(Str$(Varptr(@pVTbl[i]))) Tab(19)Varptr(@VTbl[2]) Tab(37)@VTbl[2] "   ";
    Call DWord @VTbl[2] Using ptrRelease(Varptr(@pVTbl[i])) To hr                           'Release()
    Print LTrim$(Str$(Varptr(@pVTbl[i]))) Tab(19)Varptr(@VTbl[3]) Tab(37)@VTbl[3] "   ";
    Call DWord @VTbl[3] Using ptrSetInt(Varptr(@pVTbl[i]),i) To hr                          'SetXInt() / SetYInt()
    Print LTrim$(Str$(Varptr(@pVTbl[i]))) Tab(19)Varptr(@VTbl[4]) Tab(37)@VTbl[4] "   ";
    Call DWord @VTbl[4] Using ptrGetInt(Varptr(@pVTbl[i]),iReturn) To hr                    'GetXInt() / GetYInt()
    If i Then
       strBStr="New IY String"
    Else
       strBStr="New IX String"
    End If
    Print LTrim$(Str$(Varptr(@pVTbl[i]))) Tab(19)Varptr(@VTbl[5]) Tab(37)@VTbl[5] "   ";
    Call DWord @VTbl[5] Using ptrSetText(Varptr(@pVTbl[i]),strBStr) To hr                   'SetXText() / SetYText()
    Print LTrim$(Str$(Varptr(@pVTbl[i]))) Tab(19)Varptr(@VTbl[6]) Tab(37)@VTbl[6] "   ";
    Call DWord @VTbl[6] Using ptrGetText(Varptr(@pVTbl[i]),strBStr) To hr                   'GetXText() / GetYText()
    Print
  Next i
  VTbl=@pVTbl[0]
  Call DWord @VTbl[2] Using ptrRelease(Varptr(@pVTbl[0])) To hr
  Print : Print "Leaving DumpCustomInterfaces()" : Print
End Sub


Function WinMain(ByVal hInstance As Long, ByVal hPrev As Long, ByVal lpCmdLine As Asciiz Ptr, ByVal iShow As Long) As Long
  Local regID As Dword
  Local Msg As tagMsg
  Local hr As Long
    
  If SUCCEEDED(Initialize()) Then
     If blnRegistration(hInstance, lpCmdLine, regID) Then
        Function=0
        Exit Function
     End If
  Else
     Function = -1
     Exit Function
  End If
  If InStr(@lpCmdLine,"/Embedding") Or InStr(@lpCmdLine,"-Embedding") Then
     Print "  Was Loaded By COM!"
     hr=CoRegisterClassObject($CLSID_CC, Varptr(CCClassFactory), %CLSCTX_LOCAL_SERVER, %REGCLS_MULTIPLEUSE, regID)
     If SUCCEEDED(hr) Then
        Print "  CoRegisterClassObject() Succeeded!"
        While GetMessage(Msg,%NULL,0,0)
          Call TranslateMessage(Msg)
          Call DispatchMessage(Msg)
        Wend
        CoRevokeClassObject(regID)
     Else
        Print "CoRegisterClassObject() Failed!"
        Local dwFlags As Dword
        Local szError As Asciiz*512
        dwFlags=%FORMAT_MESSAGE_FROM_SYSTEM
        FormatMessage(dwFlags, Byval 0, hr, MAKELANGID(%LANG_NEUTRAL, %SUBLANG_DEFAULT), Byval Varptr(szError), 512, Byval %NULL)
        Print "szBuffer = " szError
    End If
  Else
    Call DumpClassObject()
    Call DumpCustomInterfaces()
  End If  
  Waitkey$

  WinMain=0
End Function

#if 0
Entering Initialize()
  IClassFactory_Vtbl.QueryInterface =  4216909
  IClassFactory_Vtbl.AddRef         =  4217109
  IClassFactory_Vtbl.Release        =  4217194
  IClassFactory_Vtbl.CreateInstance =  4217287
  IClassFactory_Vtbl.LockServer     =  4218359

  Varptr(CCClassFactory)            =  4249588
  Varptr(CCClassFactory.lpVtbl)     =  4249588
  Varptr(IClassFactory_Vtbl)        =  4249592
  CCClassFactory.lpVtbl             =  4249592
  Called CCClassFactory_QueryInterface()
  Called CCClassFactory_AddRef()!
  Leaving CCClassFactory_QueryInterface()
  pClsFac =  4249588
Leaving Initialize()


Entering blnCmdLineProcessing()
Leaving blnCmdLineProcessing()


Entering DumpClassObject()
  pClassFactory         =  4249588
  @pClassFactory        =  4249592
  @pClassFactory.lpVtbl =  4249592

  pClassFactory  Varptr(@Vtbl[i]   @Vtbl[i]    Function Call Through Fn Ptr
  =======================================================================================
   4249588       4249592           4216909     Called CCClassFactory_QueryInterface()
   4249588       4249596           4217109     Called CCClassFactory_AddRef()!
   4249588       4249600           4217194     Called CCClassFactory_Release()!
   4249588       4249604           4217287     Called CCClassFactory_CreateInstance()
   4249588       4249608           4218359     Called CCClassFactory_LockServer()

Leaving DumpClassObject()

Entering DumpCustomInterfaces()
  Called CCClassFactory_CreateInstance()
    pCC      = 1279816
    @pCC.lpIX= 4249612
    @pCC.lpIY= 4249640

    1279816      4249612
    1279820      4249640

    Called IX_QueryInterface() For IID_IX And this= 1279816
    Called IX_AddRef()
    pCC  =  1279816
    pIX  =  1279816
    @ppv =  1279816
    Called CCClassFactory_AddRef()!
    Entering CCLock()
      g_lLocks =  0
      g_lLocks =  1
    Leaving CCLock()
  Leaving CBClassFactory_CreateInstance()

  VarPtr(pVTbl) =  1244064
  pVTbl         =  1279816

  Varptr(@pVTbl[i])  Varptr(@VTbl[i])  @VTbl[i]   Function Call With Call Dword
  ==============================================================================
  1279816            4249612           4214242    Called IX_QueryInterface()
  1279816            4249616           4214687    Called IX_AddRef()
  1279816            4249620           4214796    Called IX_Release()
  1279816            4249624           4214964    Called SetXInt(0)
  1279816            4249628           4215109    Called GetXInt(0)
  1279816            4249632           4215262    Setting IXText To New IX String
  1279816            4249636           4215426    IX Text: New IX String

  1279820            4249640           4215581    Called IY_QueryInterface()
  1279820            4249644           4215991    Called IY_AddRef()
  1279820            4249648           4216104    Called IY_Release()
  1279820            4249652           4216276    Called SetYInt(1)
  1279820            4249656           4216425    Called GetXInt(1)
  1279820            4249660           4216582    Setting IYText To New IY String
  1279820            4249664           4216750    IY Text: New IY String

  Entering CCUnLock()
    g_lLocks =  1
    g_lLocks =  0
  Leaving CCUnLock()

  Called IX_Release() And CC Was Deleted!
Leaving DumpCustomInterfaces()
#endif




'Entering Initialize()
'  IClassFactory_Vtbl.QueryInterface =  4216885
'  IClassFactory_Vtbl.AddRef         =  4217085
'  IClassFactory_Vtbl.Release        =  4217170
'  IClassFactory_Vtbl.CreateInstance =  4217263
'  IClassFactory_Vtbl.LockServer     =  4218335

'  Varptr(CCClassFactory)            =  4249588
'  Varptr(CCClassFactory.lpVtbl)     =  4249588
'  Varptr(IClassFactory_Vtbl)        =  4249592
'  CCClassFactory.lpVtbl             =  4249592
'  Called CCClassFactory_QueryInterface()
'  Called CCClassFactory_AddRef()!
'  Leaving CCClassFactory_QueryInterface()
'  pClsFac =  4249588
'Leaving Initialize()

'Entering blnCmdLineProcessing()
'Leaving blnCmdLineProcessing()

'Was Loaded By COM!
'Called CCClassFactory_AddRef()!
'Called CCClassFactory_AddRef()!
'Called CCClassFactory_QueryInterface()
'Called CCClassFactory_AddRef()!
'Leaving CCClassFactory_QueryInterface()
'Called CCClassFactory_Release()!
'Called CCClassFactory_AddRef()!
'Called CCClassFactory_Release()!
'Called CCClassFactory_QueryInterface()
'Called CCClassFactory_QueryInterface()
'Called CCClassFactory_QueryInterface()
'Called CCClassFactory_AddRef()!
'Leaving CCClassFactory_QueryInterface()
'Called CCClassFactory_AddRef()!
'Called CCClassFactory_QueryInterface()
'Called CCClassFactory_QueryInterface()
'Called CCClassFactory_Release()!
'Called CCClassFactory_QueryInterface()
'Called CCClassFactory_AddRef()!
'Leaving CCClassFactory_QueryInterface()
'Called CCClassFactory_QueryInterface()
'Called CCClassFactory_AddRef()!
'Leaving CCClassFactory_QueryInterface()
'Called CCClassFactory_QueryInterface()
'Called CCClassFactory_AddRef()!
'Leaving CCClassFactory_QueryInterface()
'Called CCClassFactory_LockServer()

'Entering CCLock()
'  g_lLocks =  0
'  g_lLocks =  1
'Leaving CCLock()

'Called CCClassFactory_Release()!
'Called CCClassFactory_Release()!
'Called CCClassFactory_QueryInterface()
'Called CCClassFactory_AddRef()!
'Leaving CCClassFactory_QueryInterface()
'Called CCClassFactory_LockServer()

'Entering CCUnLock()
'  g_lLocks =  1
'  g_lLocks =  0
'Leaving CCUnLock()

'Called CCClassFactory_Release()!
'Called CCClassFactory_Release()!
'Called CCClassFactory_Release()!
'Called CCClassFactory_Release()!
'CoRegisterClassObject() Succeeded!
'hr =  0

#if 0

Entering Initialize()
  IClassFactory_Vtbl.QueryInterface =  4216885
  IClassFactory_Vtbl.AddRef         =  4217085
  IClassFactory_Vtbl.Release        =  4217170
  IClassFactory_Vtbl.CreateInstance =  4217263
  IClassFactory_Vtbl.LockServer     =  4218335

  Varptr(CCClassFactory)            =  4249588
  Varptr(CCClassFactory.lpVtbl)     =  4249588
  Varptr(IClassFactory_Vtbl)        =  4249592
  CCClassFactory.lpVtbl             =  4249592
  Called CCClassFactory_QueryInterface()
    Called CCClassFactory_AddRef()!
  Leaving CCClassFactory_QueryInterface()
  pClsFac =  4249588
Leaving Initialize()

Entering blnCmdLineProcessing()
Leaving blnCmdLineProcessing()

Entering DumpClassObject()
  pClassFactory         =  4249588
  @pClassFactory        =  4249592
  @pClassFactory.lpVtbl =  4249592

  pClassFactory  Varptr(@Vtbl[i]   @Vtbl[i]    Function Call Through Fn Ptr
  =======================================================================================
   4249588       4249592           4216885     Called CCClassFactory_QueryInterface()
   4249588       4249596           4217085     Called CCClassFactory_AddRef()!
   4249588       4249600           4217170     Called CCClassFactory_Release()!
   4249588       4249604           4217263     Called CCClassFactory_CreateInstance()
   4249588       4249608           4218335     Called CCClassFactory_LockServer()
Leaving DumpClassObject()

Entering DumpCustomInterfaces()
  Called CCClassFactory_CreateInstance()
    pCC      = 1279816
    @pCC.lpIX= 4249612
    @pCC.lpIY= 4249640

    1279816      4249612
    1279820      4249640

    Called IX_QueryInterface() For IID_IX And this= 1279816
    Called IX_AddRef()
    pCC  =  1279816
    pIX  =  1279816
    @ppv =  1279816
    Called CCClassFactory_AddRef()!
    Entering CCLock()
      g_lLocks =  0
      g_lLocks =  1
    Leaving CCLock()
  Leaving CBClassFactory_CreateInstance()

  VarPtr(pVTbl) =  1244092
  pVTbl         =  1279816

  Varptr(@pVTbl[i])  Varptr(@VTbl[i])  @VTbl[i]   Function Call With Call Dword
  ==============================================================================
  1279816            4249612           4214218    Called IX_QueryInterface()
  1279816            4249616           4214663    Called IX_AddRef()
  1279816            4249620           4214772    Called IX_Release()
  1279816            4249624           4214940    Called SetXInt(0)
  1279816            4249628           4215085    Called GetXInt(0)
  1279816            4249632           4215238    Setting IXText To New IX String
  1279816            4249636           4215402    IX Text: New IX String

  1279820            4249640           4215557    Called IY_QueryInterface()
  1279820            4249644           4215967    Called IY_AddRef()
  1279820            4249648           4216080    Called IY_Release()
  1279820            4249652           4216252    Called SetYInt(1)
  1279820            4249656           4216401    Called GetXInt(1)
  1279820            4249660           4216558    Setting IYText To New IY String
  1279820            4249664           4216726    IY Text: New IY String

  Entering CCUnLock()
    g_lLocks =  1
    g_lLocks =  0
  Leaving CCUnLock()
  Called IX_Release() And CC Was Deleted!
Leaving DumpCustomInterfaces()

#endif



'C:\Code\PwrBasic\PBCC50\CC>PBTyp CC.Exe CC.rc

'PowerBASIC PBTYP TypeLib Embedder - Rev 1.0
'Copyright (c) 2007 PowerBASIC Inc.

'Module:   CC
'Target:   CC.EXE
'TypeLib:  CC.TLB
'Resource: CC.RC

'C:\Code\PwrBasic\PBCC50\CC>cc /r
'Entering Initialize()
'  Varptr(CCClassFactory)        =  4245492
'  Varptr(CCClassFactory.lpVtbl) =  4245492
'  Entering CCClassFactory_QueryInterface()
'    this= 4245492
'    Entering CCClassFactory_AddRef()!
'    Leaving CCClassFactory_AddRef()!
'  Leaving CCClassFactory_QueryInterface()
'  VarPtr(CCClassFactory) =  4245492
'Leaving Initialize()

'Entering blnCmdLineProcessing()
'  Calling ExeRegisterServer()
'  Entering ExeRegisterServer()
'    szPath         = C:\Code\PwrBasic\PBCC50\CC\CC.EXE
'    LoadTypeLib() Succeeded!
'    Entering RegisterServer()
'      szExeName  = C:\Code\PwrBasic\PBCC50\CC\CC.EXE
'      szClsid    = {20000000-0000-0000-0000-000000000020}
'      szLibid    = {20000000-0000-0000-0000-000000000023}
'      szKey      = CLSID\{20000000-0000-0000-0000-000000000020}
'  Leaving ExeRegisterServer()
'Leaving blnCmdLineProcessing()

'C:\Code\PwrBasic\PBCC50\CC>
